/*
 * $Id: ADXL335.h,v 1.5 2010/01/24 17:02:29 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: ADXL335.h,v $
 * Revision 1.5  2010/01/24 17:02:29  clivewebster
 * *** empty log message ***
 *
 * Revision 1.4  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.3  2009/11/02 18:16:23  clivewebster
 * Added revision log
 *
 * ===========
 *
 * 3 axis +-3g accelerometer from Analog Devices
 * See: http://www.sparkfun.com/datasheets/Components/SMD/adxl335.pdf
 * Supplier: http://www.sparkfun.com/commerce/product_info.php?products_id=9268
 *
 * Requires 3 ADC channels
 *
 *  Created on: 23-Sep-2009
 *      Author: Clive Webster
 *
 *  Assumes that the device uses the default 3v3 supply and that the board you
 *  are using is set up to measure ADC voltages from 0v to 5v
 *
 *  Equation for ADC10 reading to result = 14.811 * adc - 5006
 *  Equation supplied by Admin at www.societyofrobots.ocm
 *
 */

#ifndef ADXL335_H_
#define ADXL335_H_
#include "../_acceleration_common.h"
#include "../../../a2d.h"

// The class used to read a raw value
extern ACCELEROMETER_CLASS c_ADXL335;

typedef struct s_ADXL335{
	ACCELEROMETER accelerometer;
	ADC_CHANNEL x_pin;
	ADC_CHANNEL y_pin;
	ADC_CHANNEL z_pin;
} ADXL335;

// Create the sensor using X, Y and Z pins
#define MAKE_ADXL335(pinX, pinY, pinZ) { \
	MAKE_ACCELEROMETER_SENSOR(c_ADXL335), \
	pinX,\
	pinY,\
	pinZ }

#endif /* ADXL335_H_ */
