/*
 * $Id: ACCM3D2.c,v 1.5 2010/01/24 17:05:56 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: ACCM3D2.c,v $
 * Revision 1.5  2010/01/24 17:05:56  clivewebster
 * *** empty log message ***
 *
 * Revision 1.4  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.3  2009/11/02 18:17:20  clivewebster
 * Added revision log
 *
 * ===========
 * DE_ACCM3D2.c
 *
 *  Created on: 09-Sep-2009
 *      Author: Clive Webster
 *  Based on original code by Admin at www.societyofrobots.com
 *
 *  Assumes 3v3 supply where 0.666v represents one 'g'
 *
 */
#include "ACCM3D2.h"
#include "../../../a2d.h"
#include "../../../fraction.h"

static const uint16_t PROGMEM accm3d2_frac[]     = {7,  3,  189, 0};

static ACCEL_TYPE __read_channel(ADC_CHANNEL channel){
	uint16_t adc = a2dConvert10bit(channel);
	ACCEL_TYPE rtn = fraction32(adc, accm3d2_frac);
	return rtn - 2492;
}

// Read all the values and store into the device
static void __de_accm3d2_read(SENSOR* sensor){
	DE_ACCM3D2* accel = (DE_ACCM3D2*)sensor;
	__accelerometerSetX(&accel->accelerometer,__read_channel(accel->x_pin));
	__accelerometerSetY(&accel->accelerometer,__read_channel(accel->y_pin));
	__accelerometerSetZ(&accel->accelerometer,__read_channel(accel->z_pin));

}

ACCELEROMETER_CLASS c_DE_ACCM3D2 = MAKE_ACCELEROMETER_CLASS(null,&__de_accm3d2_read,0,0);


