/*
 * $Id: ACCM3D2.h,v 1.4 2010/01/24 17:05:56 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: ACCM3D2.h,v $
 * Revision 1.4  2010/01/24 17:05:56  clivewebster
 * *** empty log message ***
 *
 * Revision 1.3  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:17:20  clivewebster
 * Added revision log
 *
 * ===========
 *
 * 3 axis accelerometer from Dimension Engineering
 * See: http://www.dimensionengineering.com/DE-ACCM3D2.htm
 *
 * Requires 3 ADC channels
 *
 *  Created on: 09-Sep-2009
 *      Author: Clive Webster
 *
 *  Based on original code by Admin at www.societyofrobots.com
 *
 *  Assumes that the device uses the default 3v3 supply and that the board you
 *  are using is set up to measure ADC voltages from 0v to 5v
 *
 *  An output of 1.66v means nothing is happening
 *  The voltage changes by 0.666V per 1000mG
 *  Equation for ADC10 reading to result = 7.3387 * adc - 2492.5
 *
 *  7.3387 as a fraction is 7/1, 1/3, 1/189
 *
 */

#ifndef DE_ACCM3D2_H_
#define DE_ACCM3D2_H_
#include "../_acceleration_common.h"
#include "../../../a2d.h"

// The class used to read a raw value
extern ACCELEROMETER_CLASS c_DE_ACCM3D2;

typedef struct s_DE_ACCM3D2{
	ACCELEROMETER accelerometer;
	ADC_CHANNEL x_pin;
	ADC_CHANNEL y_pin;
	ADC_CHANNEL z_pin;
}DE_ACCM3D2;

// Create the sensor using X, Y and Z pins
#define MAKE_DE_ACCM3D2(pinX, pinY, pinZ) { \
	MAKE_ACCELEROMETER_SENSOR(c_DE_ACCM3D2), \
	pinX,\
	pinY,\
	pinZ }

#endif /* DE_ACCM3D2_H_ */
