/*
 * $Id: CMPS03.c,v 1.3 2009/12/11 17:17:55 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: CMPS03.c,v $
 * Revision 1.3  2009/12/11 17:17:55  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:20:31  clivewebster
 * Added revision log
 *
 * ===========
 * CMPS03.c
 *
 *  Created on: 27-Mar-2009
 *      Author: Clive Webster
 *
 *
 */
#include "CMPS03.h"
#include "../../../timer.h"


static void __CMPS03_read(SENSOR* sensor){
	TICK_COUNT start;
	TICK_COUNT end;

	CMPS03* compass = (CMPS03*)sensor;

	register const IOPin* pin = compass->pin;

	pin_make_input(pin,FALSE);				// Switch pin to INPUT
	while(pin_is_high(pin));				// Wait for any previous pulse to finish
	while(pin_is_low(pin));					// Wait until the start of the next pulse
	start = clockGetus();					// Get the start time
	while(pin_is_high(pin));				// Loop until the the pin goes low
	end = clockGetus();						// Get the end time

	// Get the duration in uS
	uint16_t duration = end - start;

	// The raw value is 1ms + 100us for each degree
	duration -= 1000;						// remove the 1ms start value

	compass->compass.bearingDegrees = (duration + 50) / 100;// round to the nearest degree
}

COMPASS_CLASS c_CMPS03 = MAKE_COMPASS_CLASS(null,&__CMPS03_read, 0 ,0 );
