/*
 * $Id: CMPS03.h,v 1.3 2009/12/11 17:17:55 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: CMPS03.h,v $
 * Revision 1.3  2009/12/11 17:17:55  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:20:31  clivewebster
 * Added revision log
 *
 * ===========
 * CMPS03.h
 *
 *  Created on: 26-Mar-2009
 *      Author: Clive Webster
 *
 *  Requires one I/O pin that is connected to the +5v regulated supply.
 *  On the Axon this means you must use one of the ADC pins - using other I/O pins
 *  will fry the device.
 *
 *  This library measures the pulse length from Pin4 (PWM) of the device.
 *
 *  If your application has various other interrupts happening then they will effect the
 *  accuracy of the measurement.
 *
 *  Dont forget to calibrate the compass. See http://www.robot-electronics.co.uk/htm/cmps3tech.htm
 *
 */

// TODO - must get round to I2C version. See  http://www.robot-electronics.co.uk/htm/Atmega32.htm
#ifndef CMPS03_H_
#define CMPS03_H_

#include "../_compass_common.h"

extern COMPASS_CLASS c_CMPS03;

typedef struct s_CMPS03{
	COMPASS 	 compass;
	const IOPin* pin;
}CMPS03;

#define MAKE_CMPS03(pin) { \
	MAKE_COMPASS_SENSOR(c_CMPS03), \
	pin}


#endif /* CMPS03 */
