/*
 * $Id: HMC6352.h,v 1.2 2010/02/04 19:57:12 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: HMC6352.h,v $
 * Revision 1.2  2010/02/04 19:57:12  clivewebster
 * Add functions to change the refresh rate
 *
 * Revision 1.1  2010/01/30 21:21:18  clivewebster
 * Added in Version 1.14
 *
 * ===========
 *
 *
 * HMC6352.h
 *
 *  Created on: 29-Jan-2010
 *      Author: Clive Webster
 */

#ifndef HMC6352_H_
#define HMC6352_H_

#include "../_compass_common.h"

extern COMPASS_CLASS c_HMC6352;

typedef struct s_HMC6352{
	COMPASS 	 compass;
	uint8_t		 i2cAddress;

}HMC6352;

#define MAKE_HMC6352() { \
	MAKE_COMPASS_SENSOR(c_HMC6352), \
	(0x42) & 0xfe}

#define MAKE_HMC6352_At(i2cAddress) { \
	MAKE_COMPASS_SENSOR(c_HMC6352), \
	(i2cAddress) & 0xfe}


// Set the default refresh rates
extern void HMC6352_1Hz(HMC6352* compass);
extern void HMC6352_5Hz(HMC6352* compass);
extern void HMC6352_10Hz(HMC6352* compass);
extern void HMC6352_20Hz(HMC6352* compass);


#endif /* HMC6352_H_ */
