/*
 * $Id: AC50A.h,v 1.4 2010/01/24 17:13:35 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: AC50A.h,v $
 * Revision 1.4  2010/01/24 17:13:35  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.3  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:23:50  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_AC50A.h
 *
 *  Created on: 26-Mar-2009
 *      Author: Clive Webster
 *
 *  Phidget current sensor.
 *
 *  Returns a value between 0 and +50 amps
 *
 *  Connect the device to an ADC pin
 *
 *  Phidget_AC50A sensor = MAKE_Phidget_AC50A(J1);
 *  uint8_t amps = sensorRead(sensor);
 */

#ifndef Phidget_AC50A_H_
#define Phidget_AC50A_H_
#include "../_current_common.h"
#include "../../../a2d.h"

extern CURRENT_CLASS c_Phidget_AC50A;

typedef struct s_Phidget_AC50A{
	CURRENT current;
	ADC_CHANNEL pin;
}Phidget_AC50A;

#define MAKE_Phidget_AC50A(pin) {MAKE_CURRENT_SENSOR(c_Phidget_AC50A),pin}

#endif /* Phidget_AC50A_H_ */
