/*
 * $Id: EZ1.c,v 1.5 2010/01/24 17:17:35 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: EZ1.c,v $
 * Revision 1.5  2010/01/24 17:17:35  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.4  2009/12/11 17:17:57  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.3  2009/11/02 18:32:13  clivewebster
 * Added revision log
 *
 * ===========
 *
 */
#include "EZ1.h"
#include "../../../a2d.h"
#include "../../../fraction.h"

// Based on readings in Sensor Equation Calculator
// Formula: 1.3166 * adc + 2.4752
// 1.3166
static const uint16_t PROGMEM ez1_frac[]     = {1,  4, 16, 244, 0};


// Read all the values and store into the device
static void __ez1_read(SENSOR* sensor){
	Maxbotix_EZ1* ez1 = (Maxbotix_EZ1*)sensor;
	uint16_t adc = a2dConvert10bit(ez1->adcPin);
	// Scale it
	ez1->distance.cm = fraction32(adc, ez1_frac) + 2;

//	ez1->distance.cm = adc;
}

DISTANCE_CLASS c_Maxbotix_EZ1 = MAKE_DISTANCE_CLASS(null,&__ez1_read,0,0);
