/*
 * $Id: EZ1.h,v 1.4 2010/01/24 17:17:35 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: EZ1.h,v $
 * Revision 1.4  2010/01/24 17:17:35  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.3  2009/12/11 17:17:57  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:32:13  clivewebster
 * Added revision log
 *
 * ===========
 *
 * Distance sensor from Maxbotix
 * Requires 1 ADC channel
 *
 *  Created on: 09-Sep-2009
 *      Author: Clive Webster
 *
 *
 */
#ifndef Maxbotix_EZ1_H_
#define Maxbotix_EZ1_H_
#include "../_distance_common.h"
#include "../../../a2d.h"

extern DISTANCE_CLASS c_Maxbotix_EZ1;

typedef struct s_Maxbotix_EZ1{
	DISTANCE 		distance;
	ADC_CHANNEL    	adcPin;
}Maxbotix_EZ1;

// Create the sensor
#define MAKE_Maxbotix_EZ1(adcPin) { \
	MAKE_DISTANCE_SENSOR(c_Maxbotix_EZ1), \
	adcPin }

#endif


