/*
 * $Id: GP2D15.c,v 1.6 2010/01/27 18:39:54 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: GP2D15.c,v $
 * Revision 1.6  2010/01/27 18:39:54  clivewebster
 * Combine Sharp header files into one called GP2.h
 *
 * Revision 1.5  2010/01/24 17:18:14  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.4  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.3  2009/11/02 18:32:14  clivewebster
 * Added revision log
 *
 * ===========
 *
 */
#include "GP2.h"
// Requires the floating point library
#include <math.h>

#include "../../../a2d.h"

// Read all the values and store into the device
static void __GP2D15_read(SENSOR* sensor){
	Sharp_GP2D15* device = (Sharp_GP2D15*)sensor;
	uint16_t adc = a2dConvert8bit(device->adcPin);
	device->distance.cm = 736.21 * pow(adc,-0.7922);
}

DISTANCE_CLASS c_Sharp_GP2D15 = MAKE_DISTANCE_CLASS(null,&__GP2D15_read,0,0);
