/*
 * $Id: _encoder_common.h,v 1.4 2009/11/02 18:36:20 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: _encoder_common.h,v $
 * Revision 1.4  2009/11/02 18:36:20  clivewebster
 * Added revision log
 *
 * ===========
 * _encoder_common.h
 *
 *  Created on: 20-Sep-2009
 *      Author: Clive Webster
 */

#ifndef _ENCODER_COMMON_H_
#define _ENCODER_COMMON_H_
#include "../_sensor_common.h"

// Define the data type used by all encoders for counting ticks
// Changing this will mean changing encoderDump
#define ENCODER_TYPE int16_t

// Define forward references
struct s_encoder;

// Define the api for the class
typedef struct PROGMEM c_encoder{
	SENSOR_CLASS sensor;						// include parent class
} ENCODER_CLASS;

#define MAKE_ENCODER_CLASS(init,read,startup,delay) {MAKE_SENSOR_CLASS(init,read,startup,delay)}

// Define the data for each encoder sensor
typedef struct s_encoder{
	SENSOR			sensor;						// Include fields from parent type
	ENCODER_TYPE	value;						// Last read value
} ENCODER;

#define MAKE_ENCODER_SENSOR(class) {MAKE_SENSOR(&(class.sensor)),(ENCODER_TYPE)0}

// Create macros to make the virtual methods easier to call
#define encoderRead(device) _sensorRead_(&device.encoder.sensor)
#define encoderInit(device) _sensorInit_(&device.encoder.sensor)

// Dump the value of a sensor to the rprintf destination
void _encoderDump(const ENCODER* device);
#define encoderDump(device) _encoderDump(&device.encoder);

#endif /* _ENCODER_COMMON_H_ */
