/*
 * $Id: gpsNMEA.h,v 1.1 2010/01/30 21:20:40 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: gpsNMEA.h,v $
 * Revision 1.1  2010/01/30 21:20:40  clivewebster
 * Moved to sensors foldere
 *
 * Revision 1.2  2009/11/02 18:57:28  clivewebster
 * Added revision log
 *
 * ===========
 * gpsNMEA.h
 *
 *  Created on: 07-May-2009
 *      Author: Clive Webster
 *
 * A GPS device that output NMEA compliant messages
 * The following messages are supported:-
 *   $GPRMC
 *   $GPGGA
 */

#ifndef GPSNMEA_H_
#define GPSNMEA_H_

#include "../gps.h"
#include "../../../uart.h"

// The longest possible NMEA msg length, 82 bytes plus zero delimiter
#define MAX_NMEA_MSG 83

typedef struct s_gps_nmea{
	GPS 	info;
	UART*	uart;				// The uart we are receiving the messages on
	char*	msg;				// Temporary area for the msg being received
	int		msgIndex;			// Index into msg
	boolean	error;				// is there an error in the current msg
	BAUD_RATE  baudRate;		// The baud rate to use
}GPS_NMEA;

#define MAKE_GPS_NMEA(uart,baudRate) { MAKE_GPS(), &((uart)->_uart_), null, 0, TRUE, baudRate }


// Call this routine frequently to process the incoming gps info
void gpsNMEAprocess(GPS_NMEA* gps);


#endif /* GPSNMEA_H_ */
