/*
 * $Id: gps.h,v 1.1 2010/01/30 21:20:40 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: gps.h,v $
 * Revision 1.1  2010/01/30 21:20:40  clivewebster
 * Moved to sensors foldere
 *
 * Revision 1.3  2010/01/17 02:42:44  clivewebster
 * *** empty log message ***
 *
 * Revision 1.2  2009/11/02 18:57:28  clivewebster
 * Added revision log
 *
 * ===========
 * gps.h
 *
 *  Created on: 07-May-2009
 *      Author: Clive Webster
 *
 * Define a data structure for storing the output of gps devices.
 *
 * Physical gps devices can be created using gpsNMEA.h for an NMEA compliant device.
 *
 * NB Not all GPS receivers will output all of the information.
 */

#ifndef GPS_H_
#define GPS_H_

#include "../../libdefs.h"

typedef struct s_gps {
	boolean valid;			// Is set to true once the satellites have been found and the data is valid
	double 	fixTime;		// The fix time
	double 	longitude;		// in radians
	double 	latitude;		// in radians
	double 	speed;			// in knots
	int		numSatellites;	// number of satellites
	double	altitude;		// in meters
	double  track;			// Track angle in degrees
} GPS;
#define MAKE_GPS() {FALSE,0,0,0,0,0,0,0}

#endif /* GPS_H_ */
