/*
 * $Id: Humidity.c,v 1.2 2009/11/02 18:40:29 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: Humidity.c,v $
 * Revision 1.2  2009/11/02 18:40:29  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_Humidity.c
 *
 *  Created on: 27-Mar-2009
 *      Author: Clive Webster
 */
#include "Humidity.h"
#include "../../phidgetsCommon.h"
#include "../../../fraction.h"

static const uint16_t PROGMEM phidget_humidity_frac[] = {0, 6, 36, 0};

static void __Phidget_Humidity_read(SENSOR* sensor){
	Phidget_Humidity* device = (Phidget_Humidity*)sensor;
	uint16_t adc = __phidgetsRead(device->adcPin);
	// scale it:  (0.1946 * adc)-41.98
	adc = fraction32(adc, phidget_humidity_frac);
	adc -= 42;
	device->humidity.percent = adc;
}

HUMIDITY_CLASS c_Phidget_Humidity = MAKE_HUMIDITY_CLASS(null,&__Phidget_Humidity_read, 0 ,0 );
