/*
 * $Id: Humidity.h,v 1.4 2010/01/24 17:25:34 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: Humidity.h,v $
 * Revision 1.4  2010/01/24 17:25:34  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.3  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:40:29  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_Humidity.h
 *
 *  Created on: 26-Mar-2009
 *      Author: Clive Webster
 *
 *  Phidget humidity sensor.
 *
 *  Returns a value between 10 and 95 %
 *
 *  Connect the device to an ADC pin
 *
 *  Phidget_Humidity sensor = MAKE_Phidget_Humidity(J1);
 *  int8_t humidity = sensorRead(sensor);
 */

#ifndef Phidget_Humidity_H_
#define Phidget_Humidity_H_
#include "../_humidity_common.h"
#include "../../../a2d.h"

extern HUMIDITY_CLASS c_Phidget_Humidity;

typedef struct S_Phidget_Humidity{
	HUMIDITY 	 humidity;
	ADC_CHANNEL  adcPin;
}Phidget_Humidity;

#define MAKE_Phidget_Humidity(adcPin) {MAKE_HUMIDITY_SENSOR(c_Phidget_Humidity) ,adcPin}

#endif /* Phidget_Humidity_H_ */
