/*
 * $Id: _humidity_common.h,v 1.3 2009/11/02 18:40:29 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: _humidity_common.h,v $
 * Revision 1.3  2009/11/02 18:40:29  clivewebster
 * Added revision log
 *
 * ===========
 *  Created on: 19-Sep-2009
 *      Author: Clive Webster
 *
 *  Defines the common interface for all humidity sensors
 *
 */

#ifndef HUMIDITY_H_
#define HUMIDITY_H_
#include "../_sensor_common.h"

// Define the data type used by all compasses
// Changing this will mean changing humidityDump
#define HUMIDITY_TYPE uint16_t

// Define forward references
struct s_humidity;

// Define the api for the class
typedef struct PROGMEM c_humidity{
	SENSOR_CLASS sensor;						// include parent class
} HUMIDITY_CLASS;

#define MAKE_HUMIDITY_CLASS(init,read,startup,delay) {MAKE_SENSOR_CLASS(init,read,startup,delay)}

// Define the data for each sensor
typedef struct s_humidity{
	SENSOR			sensor;						// Include fields from parent type
	HUMIDITY_TYPE	percent;						// Last read value
} HUMIDITY;

#define MAKE_HUMIDITY_SENSOR(class) {MAKE_SENSOR(&(class.sensor)),(HUMIDITY_TYPE)0}

// Create macros to make the virtual methods easier to call
#define humidityRead(device) _sensorRead_(&device.humidity.sensor)
#define humidityInit(device) _sensorInit_(&device.humidity.sensor)

// Dump the value of a sensor to the rprintf destination
void _humidityDump(const HUMIDITY* device);
#define humidityDump(device) _humidityDump(&device.humidity);


#endif /* HUMIDITY_H_ */

