/*
 * $Id: MPX5100a.c,v 1.4 2010/01/24 17:22:24 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: MPX5100a.c,v $
 * Revision 1.4  2010/01/24 17:22:24  clivewebster
 * *** empty log message ***
 *
 * Revision 1.3  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:41:41  clivewebster
 * Added revision log
 *
 * ===========
 *
 *  Created on: 24-Sep-2009
 *      Author: Clive Webster
 *
 */
#include "MPX5100a.h"
#include "../../../a2d.h"
#include "../../../fraction.h"

// 0.108613 at 16 bit
// 1/10 + 1/117 + 1/15201
static const uint16_t PROGMEM mpx5100a_frac[]     = {0, 10, 117, 15201, 0 };

#define SAMPLES 8
static void __mpx5100a_init(SENSOR* sensor){
	MPX5100A* device = (MPX5100A*)sensor;

	// Get the inital value
	uint16_t total=0;
	for(int i=0; i<SAMPLES;i++){
		total += a2dConvert10bit(device->adcPin);
	}
	device->initial = (total + (SAMPLES >> 1)) / SAMPLES;
}

// Read the value and store into the device
static void __mpx5100a_read(SENSOR* sensor){
	MPX5100A* device = (MPX5100A*)sensor;
	// read the sensor
	uint16_t adc = a2dConvert10bit(device->adcPin);

	// make relative to initial setting
	adc -= device->initial;

	PRESSURE_TYPE val = fraction32(adc,mpx5100a_frac);

	device->pressure.kPa = val;
}

// 20ms startup time
PRESSURE_CLASS c_MPX5100A = MAKE_PRESSURE_CLASS(&__mpx5100a_init,&__mpx5100a_read,20,0);



