/*
 * $Id: Temperature.c,v 1.2 2009/11/02 18:43:05 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: Temperature.c,v $
 * Revision 1.2  2009/11/02 18:43:05  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_Temperature.c
 *
 *  Created on: 27-Mar-2009
 *      Author: Clive Webster
 */
#include "Temperature.h"
#include "../../phidgetsCommon.h"
#include "../../../fraction.h"

static const uint16_t PROGMEM phidget_humidity_frac[] = {0, 6, 36, 0};

static void __Phidget_Temperature_read(SENSOR* sensor){
	Phidget_Temperature* device = (Phidget_Temperature*)sensor;
	uint16_t adc = __phidgetsRead(device->adcPin);
	// scale it:  (0.1946 * adc)-41.98
	adc -= 200;
	adc >>= 2;
	device->temperature.celsius = adc;
}

TEMPERATURE_CLASS c_Phidget_Temperature = MAKE_TEMPERATURE_CLASS(null,&__Phidget_Temperature_read, 0 ,0 );
