/*
 * $Id: Temperature.h,v 1.4 2010/01/24 17:23:22 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: Temperature.h,v $
 * Revision 1.4  2010/01/24 17:23:22  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.3  2009/12/11 17:17:56  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:43:05  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_Temperature.h
 *
 *  Created on: 26-Mar-2009
 *      Author: Clive Webster
 *
 *  Phidget temperature sensor.
 *
 *  Returns a value between -40 and +125 degrees celsius
 *
 *  Connect the device to an ADC pin
 *
 *  Phidget_Temperature sensor = MAKE_Phidget_Temperature(J1);
 *  int8_t degrees = sensorRead(sensor);
 */

#ifndef Phidget_Temperature_H_
#define Phidget_Temperature_H_
#include "../_temperature_common.h"
#include "../../../a2d.h"

extern TEMPERATURE_CLASS c_Phidget_Temperature;

typedef struct s_Phidget_Temperature{
	TEMPERATURE 	temperature;
	ADC_CHANNEL 	adcPin;
}Phidget_Temperature;

#define MAKE_Phidget_Temperature(adcPin) {MAKE_TEMPERATURE_SENSOR(c_Phidget_Temperature),adcPin}


#endif /* Phidget_Temperature_H_ */
