/*
 * $Id: 30V.h,v 1.4 2010/01/24 17:24:38 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: 30V.h,v $
 * Revision 1.4  2010/01/24 17:24:38  clivewebster
 * Use ADC channels in constructor rather than IOPins
 *
 * Revision 1.3  2009/12/11 17:17:57  clivewebster
 * Fixed #include for Unix
 *
 * Revision 1.2  2009/11/02 18:44:48  clivewebster
 * Added revision log
 *
 * ===========
 * Phidget_30V.h
 *
 *  Created on: 26-Mar-2009
 *      Author: Clive Webster
 *
 *  Phidget voltage sensor.
 *
 *  Returns a voltage between -30 and +30
 *
 *  Connect the device to an ADC pin
 *
 *  Phidget_30V sensor = MAKE_Phidget_30V(J1);
 *  int8_t volts = sensorRead(sensor);
 */

#ifndef Phidget_30V_H_
#define Phidget_30V_H_
#include "../_voltage_common.h"
#include "../../../a2d.h"

extern VOLTAGE_CLASS c_Phidget_30V;

typedef struct s_Phidget_30V{
	VOLTAGE voltage;
	ADC_CHANNEL adcPin;
}Phidget_30V;

#define MAKE_Phidget_30V(adcPin) {MAKE_VOLTAGE_SENSOR(c_Phidget_30V),adcPin}

#endif /* Phidget_30V_H_ */
