/*
 * $Id: _i2c_common.c,v 1.3 2009/11/02 18:48:32 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: _i2c_common.c,v $
 * Revision 1.3  2009/11/02 18:48:32  clivewebster
 * Added revision log
 *
 * ===========
 * _i2c_common.c
 *
 *  Created on: 10-Sep-2009
 *      Author: Clive Webster
 */
#include "_i2c_common.h"


// The current state of the I2C hardware
volatile i2cStateType i2cState;

// Include the device definitions
#include <avr/io.h>




void i2cSetBitrate(uint16_t bitrateKHz){
	uint8_t bitrate_div;

	// set i2c bitrate
	// SCL freq = F_CPU/(16+2*TWBR))
	#ifdef TWPS0
		// for processors with additional bitrate division (mega128)
		// SCL freq = F_CPU/(16+2*TWBR*4^TWPS)
		// set TWPS to zero to make = F_CPU/(16+2*TWBR)
		cbi(TWSR, TWPS0);
		cbi(TWSR, TWPS1);
	#endif

	// calculate bitrate division
	bitrate_div = cpu_speed_div_1000 / bitrateKHz;

	if(bitrate_div >= 16)
		bitrate_div = (bitrate_div-16)/2;

	outb(TWBR, bitrate_div);
}







