/*
 * $Id: _i2c_common.h,v 1.3 2009/11/02 18:48:32 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: _i2c_common.h,v $
 * Revision 1.3  2009/11/02 18:48:32  clivewebster
 * Added revision log
 *
 * ===========
 * _i2c_common.h
 *
 *  Created on: 10-Sep-2009
 *      Author: Clive Webster
 */

#ifndef _I2C_COMMON_H_
#define _I2C_COMMON_H_

#include "libdefs.h"

typedef enum{
	I2C_IDLE=0,
	I2C_BUSY,
	I2C_MASTER_TX,
	I2C_MASTER_RX,
	I2C_SLAVE_TX,
	I2C_SLAVE_RX
} i2cStateType;

extern volatile i2cStateType i2cState;


// ----- public methods: available to applications ------------
// Set the bit rate in kHz. Default is 100kHz
void i2cSetBitrate(uint16_t bitrateKHz);

#endif /* _I2C_COMMON_H_ */
