/*
 * $Id: actuators.c,v 1.4 2009/11/02 18:52:38 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: actuators.c,v $
 * Revision 1.4  2009/11/02 18:52:38  clivewebster
 * Added revision log
 *
 * ===========
 * actuators.c
 *
 *  Created on: 15-Mar-2009
 *      Author: Clive Webster
 */
#include "actuators.h"


void __act_setSpeed(__ACTUATOR* act, DRIVE_SPEED speed){
	// clamp it to the given range
	speed = CLAMP(speed, DRIVE_SPEED_MIN, DRIVE_SPEED_MAX);

	// Get the driver class
	const __ACTUATOR_DRIVER_CLASS* driver=act->class;

	// Call the setSpeed method on the class
	if(driver){
		void (*fn)(__ACTUATOR*,DRIVE_SPEED speed) = (void (*)(__ACTUATOR*, DRIVE_SPEED speed))pgm_read_word(&driver->setSpeed);
		if(fn!=null){
			fn(act,(act->inverted) ? speed*-1 : speed);
		}
	}

	// Store the new speed - do this at the end so that the setSpeed method
	// can access the previous speed
	act->required_speed = speed;
}


void __act_setConnected(__ACTUATOR* act,boolean connected){
	// Change the variable
	act->connected = connected;

	// Get the driver class
	const __ACTUATOR_DRIVER_CLASS* driver=act->class;

	// Call the setSpeed method on the class
	if(driver){
		void (*fn)(__ACTUATOR*,boolean connected) = (void (*)(__ACTUATOR*, boolean connected))pgm_read_word(&driver->setConnected);
		if(fn!=null){
			fn(act,connected);
		}
	}
}

DRIVE_SPEED __act_getSpeed(const __ACTUATOR* act){
	return act->required_speed;
}

boolean __act_isConnected(const __ACTUATOR* act){
	return act->connected;
}

boolean __act_isInverted(const __ACTUATOR* act){
	return act->inverted;
}


//void __act_AttachSpeedCallback(__ACTUATOR* act,void (*speedCallback)(__ACTUATOR *actuator, DRIVE_SPEED speed)) {
//	act->speedCallback = speedCallback;
//	__act_setSpeed(act, __act_getSpeed(act));
//}
//
//void __act_AttachConnectCallback(__ACTUATOR* act,void (*connectCallback)(__ACTUATOR *actuator, boolean connected)){
//	act->connectCallback = connectCallback;
//}
