
/*
 * $Id: buffer2.c,v 1.1 2010/01/24 12:12:03 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: buffer2.c,v $
 * Revision 1.1  2010/01/24 12:12:03  clivewebster
 * *** empty log message ***
 *
 * ===========
 *
 *
 * buffer2.c
 *
 *  Created on: 21-Jan-2010
 *      Author: Clive Webster
 */
#include "buffer.h"

// dump (discard) the first numbytes from the front of the buffer
void bufferDump(cBuffer* buffer, unsigned short numbytes){
	// begin critical section
	CRITICAL_SECTION_START;
		// dump numbytes from the front of the buffer
		// are we dumping less than the entire buffer?
		if(numbytes < buffer->datalength)
		{
			// move index down by numbytes and decrement length by numbytes
			buffer->dataindex = (buffer->dataindex + numbytes) % buffer->size;
			buffer->datalength -= numbytes;
		}
		else
		{
			// flush the whole buffer
			buffer->datalength = 0;
		}
		// end critical section
	CRITICAL_SECTION_END;
}

// get a byte at the specified index in the buffer (kind of like array access)
// ** note: this does not remove the byte that was read from the buffer
unsigned char	bufferGetAtIndex(cBuffer* buffer, unsigned short index){
	unsigned char data;
	// begin critical section
	CRITICAL_SECTION_START;
		// return character at index in buffer
		data = buffer->dataptr[(buffer->dataindex+index)%(buffer->size)];
		// end critical section
	CRITICAL_SECTION_END;
	return data;
}


