/*
 * $Id: color1.c,v 1.5 2010/02/04 19:40:14 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: color1.c,v $
 * Revision 1.5  2010/02/04 19:40:14  clivewebster
 * Add function to compare two colors
 *
 * Revision 1.4  2009/11/02 18:54:58  clivewebster
 * *** empty log message ***
 *
 * ===========
 * color1.c
 *
 *  Created on: 02-Sep-2009
 *      Author: Clive Webster
 */
#include "color.h"
#include <string.h>		// for memcpy


// Convert the color to RGB
COLOR_RGB* color2rgb(const COLOR * src, COLOR* dest){		// Convert the color to RGB
	switch(src->colorSpace){

	case RGB:{
		// Nothing to do
		if(dest!=src){
			memcpy(dest, src, sizeof(COLOR));
		}
		break;
		}
	case YUV:{

		/* Convert yuv to rgb
		r = (int) (( 298.082 * Y               + 408.583 * V  ) / 256 - 222.921);
		g = (int) (( 298.082 * Y - 100.291 * U - 208.120 * V  ) / 256 + 135.576);
		b = (int) (( 298.082 * Y + 516.412 * U                ) / 256 - 276.836);
		*/

		int Y = src->bands.yuv.y;
		int Cb = src->bands.yuv.u;
		int Cr = src->bands.yuv.v;

		int r,g,b;
		r = (int) (( 298.082 * Y                + 408.583 * Cr ) / 256 - 222.921);
		g = (int) (( 298.082 * Y - 100.291 * Cb - 208.120 * Cr ) / 256 + 135.576);
		b = (int) (( 298.082 * Y + 516.412 * Cb                ) / 256 - 276.836);

		r = CLAMP(r,0,255);
		g = CLAMP(g,0,255);
		b = CLAMP(b,0,255);
		colorSetRGB(dest,r,g,b);
		break;
		}
	}
	return &dest->bands.rgb;
}

