
/*
 * $Id: color3.c,v 1.1 2010/02/04 19:40:14 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: color3.c,v $
 * Revision 1.1  2010/02/04 19:40:14  clivewebster
 * Add function to compare two colors
 *
 * ===========
 *
 *
 * color3.c
 *
 *  Created on: 02-Feb-2010
 *      Author: Clive Webster
 */
#include "color.h"

// Test if two colors are identical
boolean colorEquals(const COLOR* c1, const COLOR* c2){
	if(c1 == c2){
		return TRUE;
	}

	if(c1->colorSpace != c2->colorSpace){
		return FALSE;
	}

	boolean rtn = FALSE;
	if(c1->colorSpace == RGB){
		// RGB
		if(c1->bands.rgb.r == c2->bands.rgb.r &&
		   c1->bands.rgb.g == c2->bands.rgb.g &&
		   c1->bands.rgb.b == c2->bands.rgb.b){
			rtn = TRUE;
		}
	}else{
		// YUV
		if(c1->bands.yuv.y == c2->bands.yuv.y &&
		   c1->bands.yuv.u == c2->bands.yuv.u &&
		   c1->bands.yuv.v == c2->bands.yuv.v){
			rtn = TRUE;
		}
	}
	return rtn;
}

