/*
 * $Id: fraction.h,v 1.2 2009/11/02 18:56:42 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: fraction.h,v $
 * Revision 1.2  2009/11/02 18:56:42  clivewebster
 * Added revision log
 *
 * ===========
 * fraction.h
 *
 *  Created on: 02-Sep-2009
 *      Author: Clive Webster
 *
 *  Perform fraction arithmetic
 *
 *  Passed in fraction series are assumed to be a fibonacci sequence ie the numerators are all equal to 1
 *
 */

#ifndef FRACTION_H_
#define FRACTION_H_

#include "libdefs.h"

// Value is the value to multiply by the fraction
// Fraction is the fraction (in Progmem) where the first element is the integer element to the left of
// the decimal point, and the remainding elements are the divisors where 0 denotes the end of the list
// So multiply the value 10 by 3.5 then fraction32(10, (3,2,0} ) ie (val*3)+(val/2)
int32_t fraction32(int16_t value, const uint16_t * fraction );


#endif /* FRACTION_H_ */
