/*
 * $Id: i2c_master.h,v 1.2 2009/11/02 18:58:48 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: i2c_master.h,v $
 * Revision 1.2  2009/11/02 18:58:48  clivewebster
 * Added revision log
 *
 * ===========
 * i2c_master.h
 *
 *  Created on: 29-Apr-2009
 *      Author: Clive Webster
 *
 *  Provide support for an I2C/TWI master device using hardware
 *  The bus should have external pullup resistors.
 *  According to the data sheet these should have a minimum value of
 *  (Vcc - 0.4)/3 in kohms. ie for 5v supply = 4.6/3 kOhms =   1.6k but 4.7k is more often used
 */

#ifndef I2C_MASTER_H_
#define I2C_MASTER_H_

#include "_i2c_common.h"

// Return TRUE if ok, or FALSE if no device or error
boolean i2cMasterSend(uint8_t deviceAddr, size_t length, const uint8_t* data);
boolean i2cMasterReceive(uint8_t deviceAddr, size_t length, uint8_t *data);

#endif /* I2C_MASTER_H_ */
