/*
 * $Id: led.h,v 1.3 2009/11/02 19:00:09 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: led.h,v $
 * Revision 1.3  2009/11/02 19:00:09  clivewebster
 * Added revision log
 *
 * ===========
 *
 */
#ifndef _LED_H_
#define _LED_H_

#include "iopin.h"

typedef struct s_led {
	const IOPin* pin;
	boolean activeHigh:1;
	boolean initialised:1;
} LED;

#define MAKE_LED(pin, activehigh) {pin, activehigh, FALSE }

// The status LED
extern LED statusLED;



void LED_set(LED* led,	boolean value);

static __inline__ void LED_on(LED* led){
	LED_set(led,TRUE);
}

static __inline__ void LED_off(LED* led){
	LED_set(led,FALSE);
}

static __inline__ void statusLEDregister(const IOPin* pin, boolean activeHigh){
	statusLED.pin = pin;
	statusLED.activeHigh = activeHigh;
	statusLED.initialised=FALSE;
	LED_on(&statusLED);
}

static __inline__ void statusLED_on(){
	if(pin_is_output(statusLED.pin)){
		LED_on(&statusLED);
	}
}

static __inline__ void statusLED_off(){
	if(pin_is_output(statusLED.pin)){
		LED_off(&statusLED);
	}
}

static __inline__ void statusLED_set(boolean value){
	LED_set(&statusLED, value);
}




#endif
