/*
 * $Id: motorPWM.h,v 1.6 2009/11/02 19:00:09 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: motorPWM.h,v $
 * Revision 1.6  2009/11/02 19:00:09  clivewebster
 * Added revision log
 *
 * ===========
 * motorPWM.h
 *
 *  Created on: 24-Mar-2009
 *      Author: Clive Webster
 *
 *  A motor driver that uses one PWM for speed, and one output pin for direction.
 *  This includes my motor drivers at:
 *  http://www.societyofrobots.com/member_tutorials/node/159
 */

#ifndef MOTORPWM_H_
#define MOTORPWM_H_

#include "actuators.h"


typedef struct s_motor{
	__ACTUATOR 	actuator;		// has all the common stuff
	const IOPin *pin;		// The IO pin the motor is connected to - must be a timer compare pin
	const IOPin *enable1;	// The IO pin used to set the direction of the motor
} MOTOR;


// Define the standard constructor for a dc motor
#define MAKE_MOTOR(inverted, motorPin, directionPin)  { MAKE_ACTUATOR(inverted),motorPin,directionPin}


typedef MOTOR* PROGMEM  MOTOR_LIST;

typedef struct s_motor_driver{
	MOTOR_LIST* const motors;		// The motors
	uint8_t num_motors; 			// The total number of motors
} MOTOR_DRIVER;

#define MAKE_MOTOR_DRIVER(motorlst) { \
	motorlst, \
	(uint8_t)(sizeof(motorlst)/sizeof(MOTOR*)) \
}


void motorPWMInit(MOTOR_DRIVER* driver);


#endif /* MOTORPWM_H_ */
