/*
 * $Id: pinChange.h,v 1.2 2009/11/02 19:00:56 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: pinChange.h,v $
 * Revision 1.2  2009/11/02 19:00:56  clivewebster
 * Added revision log
 *
 * ===========
 * pinChange.h
 *
 *  Created on: 03-Apr-2009
 *      Author: Clive Webster
 */

#ifndef PINCHANGE_H_
#define PINCHANGE_H_

#include "iopin.h"

/******************************************************

	Functionality to attach a callback routine that
	is called as an interrupt when the poin changes.
	This is not support on ATMega8/32 processors

******************************************************/
// Define a callback for PinChange events
typedef void (*PinChangeCallback)(const IOPin* io,boolean val, volatile void* data);

typedef struct s_pinchange{
	volatile PinChangeCallback callback;
	volatile void*			   data;
	volatile boolean		   lastValue;
}PIN_CHANGE;



void pin_change_attach(const IOPin* io,PinChangeCallback callback, void* data);
void pin_change_dettach(const IOPin* io);


#if defined(BUILDING_LIBRARY)
// we are building the lib
extern const IOPin* PROGMEM PCINT_PINS[];
extern const uint8_t NUM_PCINT_PINS;
extern PIN_CHANGE pcCallbacks[];
#else
// we are building the app
#ifdef _NUM_PCINT_PINS
PIN_CHANGE pcCallbacks[_NUM_PCINT_PINS];
#else
#error "This device does not support Pin Change interrupts"
#endif
#endif
#endif /* PINCHANGE_H_ */
