/*
 * $Id: rprintfHexDump.c,v 1.2 2009/11/02 19:02:47 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: rprintfHexDump.c,v $
 * Revision 1.2  2009/11/02 19:02:47  clivewebster
 * Added revision log
 *
 * ===========
 * rprintfHexDump.c
 *
 *  Created on: 22-Aug-2009
 *      Author: Clive Webster
 */

#include "rprintf.h"
#include "libdefs.h"


void rprintfMemoryDump(const void* data, size_t off, size_t len){
    int x;
    int c;
    int line;
    const uint8_t * b= (const uint8_t *)data;

    rprintf("ADDR|  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F | ASCII\n");
    rprintfCharN('-',72); rprintfCRLF();
    for(line = 0; line < ((len % 16 != 0) ? (len / 16) + 1 : (len / 16)); line++){
    	int line16 = line * 16;
    	rprintfu16(line16);
        rprintf("| ");

        // put hex values
        for(x = 0; x < 16; x++){
            if(x + line16 < len){
                c = b[off + x + line16];
                rprintfu08(c);
                rprintfChar(' ');
            }else{
                rprintfCharN(' ',3);
            }
        }
        rprintfChar('|');rprintfChar(' ');

        // put ascii values
        for(x = 0; x < 16; x++){
            if(x + line16 < len){
                c = b[off + x + line16];
                if((c > 0x1f) && (c < 0x7f)){
                	// ascii
                    rprintfChar((unsigned char)c);
                }else{
                	// non ascii
                	rprintfChar('.');
                }
             }else{
             	rprintfChar(' ');
             }
        }
        rprintfCRLF();
    }
    rprintfCharN('-',72); rprintfCRLF();
}
