/*
 * $Id: rprintfStrLen.c,v 1.1 2010/01/24 12:13:32 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: rprintfStrLen.c,v $
 * Revision 1.1  2010/01/24 12:13:32  clivewebster
 * *** empty log message ***
 *
 * ===========
 *
 *
 * rprintfStrLen.c
 *
 *  Created on: 21-Jan-2010
 *      Author: Clive Webster
 */
#include "rprintf.h"


// prints a section of a string stored in RAM
// begins printing at position indicated by <start>
// prints number of characters indicated by <len>
void rprintfStrLen(char str[], unsigned int start, unsigned int len)
{
	if(str){
		register int i=0;

		// spin through characters up to requested start
		// keep going as long as there's no null
		while( (i++<start) && (*str) ){
			str++;
		}

		// then print exactly len characters
		while(len--)
		{
			// print data out of the string as long as we haven't reached a null yet
			// at the null, start printing spaces
			rprintfChar( (*str) ? *str++ : ' ');
		}
	}
}
