/*
 * $Id: spi.h,v 1.4 2009/11/02 19:05:46 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: spi.h,v $
 * Revision 1.4  2009/11/02 19:05:46  clivewebster
 * Added revision log
 *
 * ===========
 * spi.h
 *
 *  Created on: 23-Jun-2009
 *      Author: Clive Webster
 *
 *  An implementation of the SPI interface using the hardware pins MISO,MOSI,and SCLK
 *
 *
 */

#ifndef SPI_H_
#define SPI_H_

// Include stuff that is common to all SPI implementations
#include "_spi_common.h"

#if defined (__AVR_ATmega640__)
#elif defined (__AVR_ATmega2560__)
#elif defined (__AVR_ATmega168__)
#elif defined (__AVR_ATmega8__)
#elif defined (__AVR_ATmega32__)
#elif defined (__AVR_ATmega328P__)
#else
#    error "This device is not currently supported"
#endif


// Define the data stored for a harware spi interface
typedef struct s_spi {
	_SPI			_spi_;	// Include data common for ALL spi interfaces
} SPI;

// Class definition for a hardware SPI
extern SPI_CLASS c_hw_spi;

// Constructor for a hardware SPI interface
#define MAKE_SPI(devices) {_MAKE_SPI(&c_hw_spi, devices) }


#endif /* SPI_H_ */
