/*
 * $Id: spiUart.h,v 1.3 2009/11/02 19:05:46 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: spiUart.h,v $
 * Revision 1.3  2009/11/02 19:05:46  clivewebster
 * Added revision log
 *
 * ===========
 * spiUart.h
 *
 *  Created on: 26-Jun-2009
 *      Author: Clive Webster
 *
 *  An SPI interface using a Uart. The Uarts only support master mode.
 *
 *  Note that not all uarts support this mode: notably the ATMega8 and ATMega32 do not
 *  support it at all but the ATMega168 and ATMega640 do.
 */

#ifndef SPIUART_H_
#define SPIUART_H_

// Include stuff that is common to all SPI implementations
#include "_spi_common.h"
#include "uart.h"

// Class definition for a uart SPI
extern SPI_CLASS c_uart_spi;


// Define the data stored for a uart spi interface
typedef struct s_spi_uart {
	_SPI			_spi_;		// Include data common for ALL spi interfaces
	HW_UART*		uart;		// The UART hardware to be used
} SPI_UART;



// Constructor for a uart SPI interface
#define MAKE_UART_SPI(devices,uart) { _MAKE_SPI(&c_uart_spi,devices),uart}


#endif /* SPIUART_H_ */
