/*
 * $Id: spisw.h,v 1.4 2009/11/02 19:05:46 clivewebster Exp $
 *
 * Revision History
 * ================
 * $Log: spisw.h,v $
 * Revision 1.4  2009/11/02 19:05:46  clivewebster
 * Added revision log
 *
 * ===========
 * spisw.h
 *
 *  Created on: 24-Jun-2009
 *      Author: Clive Webster
 *
 *  An implementation of the SPI interface using software
 *  where any pins can be used for MOSI,MISO,SCLK etc
 *
 *  Currently only master mode is supported
 */

#ifndef SPISW_H_
#define SPISW_H_

// Include stuff that is common to all SPI implementations
#include "_spi_common.h"
//#include "pinChange.h"		// Define the pin change callbacks - for slave mode

// Define the data stored for a harware spi interface
typedef struct s_spi_sw {
	_SPI			_spi_;		// Include data common for ALL spi interfaces
	const IOPin*	MOSI;		// The pins to use for the bus
	const IOPin*	MISO;		// The pins to use for the bus
	const IOPin*	SCLK;		// The pins to use for the bus
} SPI_SW;

// Class definition for a hardware SPI
extern SPI_CLASS c_sw_spi;

// Constructor for a hardware SPI interface
#define MAKE_SW_SPI(devices,mosi,miso,sclk) {_MAKE_SPI(&c_sw_spi,devices),mosi,miso,sclk}



#endif /* SPISW_H_ */
