#ifndef _BABY_ORGANUTAN_B168_H_
#define _BABY_ORGANUTAN_B168_H_

/* ------------------------------------------------------
 * $Id$
 *
 * Revision History
 * ================
 * $Log$
 * ===========
 
	Baby Orangutan board B168

	This device is no longer manufactured

	Runs at 20Mhz ATMega168

	Has integral TB6612FNG motor driver.
	Motor 1 uses PB3 and PD3
	Motor 2 uses PD5 and PD6

-------------------------------------------------------*/
#ifdef THE_SYSTEM
#error You must only include one system file
#endif

#define THE_SYSTEM BABYORANGUTAN_B168

#ifndef F_CPU
#warning No CPU speed specified - assuming Baby Orangutan B168 is running at 20MHz
#define F_CPU 20000000
#endif

#if F_CPU != 20000000
#warning Baby Orangutan B168 normally runs at 20MHz but you have defined a different value
#endif

#if defined (__AVR_ATmega168__)
#else
#	error When using the Baby Orangutan B168 you must set the device to the ATMega168
#endif



#include "../core.h"


// ---------------   Start: define IO pins ---------------------
#include <avr/io.h>



void __ports(void){
};


// Now #undef any pins that are not connected...
#undef PB3	// Used by motor 1
#undef PD3	// Used by motor 1
#undef PD5	// Used by motor 2
#undef PD6	// Used by motor 2
#undef PC6	// Disables motors

#undef PB6	// Used by the 20MHz crystal
#undef PB7	// Used by the 20MHz crystal
#undef PC6	// Used by reset

#undef PC7	// Attached to trimmer pot

// ... before calling
 #include "../device.h"


/**

	Each system must define this method. It is called
	by the main in core.h just before entering the
	applications own 'control' method

	Set up the I/O ports with their standard settings

*/
void configure_ports(void){
 	__ports();
 }


// ---------------   End: define IO pins ---------------------


// Define common info for timers
#include "../timer.h"

void registerLED(void){
	// Register the built in LED
	statusLEDregister(D1, TRUE);
}

// Initialise any other hardware, like motor drivers etc, built onto the board
void sysInitHardware(void){
}

#endif
